<template>
  <div class="card" :data-testid="subtitle">
    <div v-if="image" class="image">
      <img :src="image" :alt="imageAlt || title" />
    </div>
    <div class="header">
      <h3 v-if="$slots.title || title" class="title">
        <template v-if="$slots.title">
          <!-- @slot Use this or the `title` attribute but not both -->
          <slot name="title"></slot>
        </template>
        <template v-else>{{ title }}</template>
      </h3>
      <p v-if="subtitle" class="subtitle">{{ subtitle }}</p>
    </div>
    <div v-if="$slots.body" class="body">
      <slot name="body"></slot>
    </div>
    <div v-if="$slots.footer" class="footer">
      <slot name="footer"></slot>
    </div>
  </div>
</template>

<script>
export default {
  name: 'SaCard',
  props: {
    /** Use this or the `title` slot but not both */
    title: {
      type: String,
      default: ''
    },
    subtitle: {
      type: String,
      default: null
    },
    /** Image URI to display as the card header */
    image: {
      type: String,
      default: null
    },
    /** `alt` text for image header */
    imageAlt: {
      type: String,
      default: null
    }
  }
}
</script>

<style lang="scss" scoped>
.card {
  display: flex;
  flex-direction: column;
  width: 100%;
  border: border(grey-light);
  border-radius: $border-radius;
  padding: spacing(1);

  > div {
    padding: spacing(1);
  }

  .image {
    padding: 0;
    margin: -#{spacing(1)};
    margin-bottom: spacing(1);

    img {
      width: 100%;
      border-radius: $border-radius $border-radius 0 0;
    }
  }
}
.title {
  font-size: font-size(3);
}
.subtitle {
  font-size: font-size(0);
  color: color(grey);
}
.body {
  flex-grow: 1;
  > * + * {
    margin-top: spacing(2);
  }
}
</style>
